package com.caimei365.manager.service.caimei.svip;

import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.CmUser;
import com.caimei365.manager.entity.caimei.svip.CmSvipGive;
import com.caimei365.manager.entity.caimei.svip.CmSvipHistory;
import com.caimei365.manager.entity.caimei.svip.CmSvipPackage;
import com.caimei365.manager.entity.caimei.svip.CmSvipProduct;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
public interface CmSvipHistoryService {

    /**
     * 超级会员列表
     * @param vip
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmSvipHistory>> memberList(CmSvipHistory vip, Integer pageNum, Integer pageSize);

    /**
     * 获取机构信息
     * @param clubId
     * @param name
     * @param shortName
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmUser>> findClubList(Integer clubId, String name, String shortName, Integer pageNum, Integer pageSize);

    /**
     * 赠送超级会员
     * @param cmSvipGive
     * @return
     */
    ResponseJson saveGive(CmSvipGive cmSvipGive) throws Exception ;

    /**
     * 获取购买记录
     * @param cmSvipHistory
     * @return
     */
    ResponseJson<PaginationVo<CmSvipHistory>> findHistory(CmSvipHistory cmSvipHistory, int pageNum, int pageSize);

    /**
     *超级会员优惠商品
     * @param svipProduct
     * @param pageNum
     * @param pageSize
     * @return
     */
    ResponseJson<PaginationVo<CmSvipProduct>> findProductList(CmSvipProduct svipProduct, Integer pageNum, Integer pageSize);

    /**
     * 套餐配置
     * @return
     */
    ResponseJson<CmSvipPackage> findPackage();

    /**
     * 更新超级会员套餐信息
     * @param cmSvipPackage
     * @return
     */
    ResponseJson updatePrice(CmSvipPackage cmSvipPackage);
}
